#include <Wire.h>

#define Addr 0x1E                         // 7-bit address of HMC5883 compass

void setup() {
  Serial.begin(9600);
  delay(100);                            // Power up delay
  Wire.begin();
  
  // Set operating mode to continuous
  Wire.beginTransmission(Addr); 
  Wire.send(0x02);
  Wire.send(0x00);
  Wire.endTransmission();
}

void loop() {
  int x, y, z;

  // Initiate communications with compass
  Wire.beginTransmission(Addr);
  Wire.send(0x03);                         // Send request to X MSB register
  Wire.endTransmission();

  Wire.requestFrom(Addr, 6);               // Request 6 bytes; 2 bytes per axis
  if(Wire.available() <=6) {               // If 6 bytes available
    x = Wire.receive() << 8 | Wire.receive();
    z = Wire.receive() << 8 | Wire.receive();
    y = Wire.receive() << 8 | Wire.receive();
  }
  
  // Print values
  Serial.print("X=");
  Serial.print(x);
  Serial.print(", Y=");
  Serial.print(y);
  Serial.print(", Z=");
  Serial.println(z);
  
  delay(500);
}
